//
//  **************************************************************************
//
//  dialog.h
//  (C) 2003 Bosco K. Ho 
//
//  **************************************************************************
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation; either version 2.1 of the License, or (at
//  your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,  but
//  WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details. 
//  
//  You should have received a copy of the GNU Lesser General Public License 
//  along with this program; if not, write to the Free Software Foundation, 
//  Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//  **************************************************************************
//

#ifndef _my_dialog_h_
#define _my_dialog_h_

#include "wx/dcbuffer.h"
#include "wx/wx.h"
#include "wx/spinctrl.h"
#include "controller.h"



//////////////////////////////////////////////
// TorsionDialog
//////////////////////////////////////////////

class TorsionDialog: public wxDialog
{
public:
    TorsionDialog(wxWindow *parent, 
                  Controller* pController);

    void OnOk(wxCommandEvent& event);
    Controller* mpController;

    wxSpinCtrl* mpPhiSpinCtrl;
    wxSpinCtrl* mpPsiSpinCtrl;
    wxSpinCtrl* mpChi1SpinCtrl;
    wxSpinCtrl* mpChi2SpinCtrl;
    wxSpinCtrl* mpChi3SpinCtrl;
    
private:
    DECLARE_EVENT_TABLE()
};


class PopupMenu
{
public:
    PopupMenu(wxWindow *parent, Controller* pController):
              mpParent(parent), mpController(pController) {};
    void show(int x, int y);
private:
    wxWindow* mpParent;
    Controller* mpController;
};


#endif               
