//
//  **************************************************************************
//
//  widget.h 
//
//  (C) 2003 Bosco K. Ho 
//
//  **************************************************************************
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation; either version 2.1 of the License, or (at
//  your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,  but
//  WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details. 
//  
//  You should have received a copy of the GNU Lesser General Public License 
//  along with this program; if not, write to the Free Software Foundation, 
//  Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//  **************************************************************************
//

#ifndef _widget_h
#define _widget_h

#include <string>
#include <vector>
#include <list>
#include <sstream>     
#include <iomanip>

#include "wx/dcbuffer.h"
#include "wx/wx.h"
#include "wx/spinctrl.h"

#include "graphic3d.h"



class Widget 
{
public:
  Widget(wxWindow* pParent, int x, int y, int width, int height) :
    mpParent(pParent), mX(x), mY(y), mWidth(width), mHeight(height) {}
  virtual ~Widget() {}

  virtual void onLeftMouseDown() {}
  virtual void onLeftMouseDClick() {}
  virtual void onLeftMouseDrag() {}
  virtual void onLeftMouseUp() {}
  virtual void onRightMouseDown() {}
  virtual void onRightMouseDrag() {}
  virtual void onRightMouseUp() {}

  virtual bool isOn() { return true; }
  virtual void OnMouseMove(int x, int y) 
     { mMouseX = x; mMouseY = y; }

  wxSize GetClientSize()
      { return mpParent->GetClientSize(); }

  virtual bool isInside (int x, int y);

  virtual int getX();
  virtual int getY();
   
  virtual int getWidth();
  virtual int getHeight();
   
  virtual void draw (wxBufferedPaintDC& dc) = 0;
  virtual void Refresh() { mpParent->Refresh(); }

  wxWindow* mpParent;

  int mX;
  int mY;

  int mWidth;
  int mHeight;

  int mMouseX;
  int mMouseY;
  
};

#endif
